PImage img; // image contenant les animations
PImage sprite; // stockera l'image a afficher
PImage sprites[][]; //tableau des images d'animation
PImage feux[]; //tableau des images d'animation
int timer; // pour mesurer le temps entre 2 anim
int index=0, indexTir=0; // pour se situer dans l'anim. Varie entre 0 et 7
int colonne=0, ligne=0; 
int posX=500, posY=300, cibleTirX, cibleTirY, tirX, tirY;// position du dragon
int deltaX, deltaY, departAnim; // 
float angle, proportionDeplacement=0.1;
boolean demandeTir=false, cracherFeu=false, lancerTir=false,attaqueCaudale=false;

void setup() { 
  size(1000, 600);
  img = loadImage("wyvern_composite.png"); // image contenant les animations
  sprites=new PImage[56][8]; // on récupére les images d'animation
  for (int y = 0; y < 8; y++) {
    for (int x = 0; x < 56; x++) {
      sprites[x][y] = img.get(x*256, y*256, 256, 256);
    }
  }
  img = loadImage("explosion_1_38_128_corrected.png"); // image contenant les animations du feu
  feux=new PImage[40]; // on récupére les images d'animation
  for (int y = 0; y < 5; y++) {
    for (int x = 0; x < 8; x++) {
      feux[y*8+x] = img.get(x*128, y*128, 128, 128);
    }
  }
} 
void draw() {
  if (mousePressed&&!demandeTir) {// on tire s'il n'y a pas de tir en route
    indexTir=0; 
    demandeTir=true;
    cibleTirX=mouseX; // enregistrement position de la cible
    cibleTirY=mouseY;
    proportionDeplacement=0.02; // on ralentit le dragon pour tirer
  } 
  if (lancerTir) { // animer la boule de feu en la direigeant vers la cible
    tirX+=round((cibleTirX-tirX)*0.1);
    tirY+=round((cibleTirY-tirY)*0.1);
    println("indexTir"+indexTir+" lancerTir"+lancerTir+" frame="+frameCount);
    image(feux[round(indexTir/1)], tirX-64, tirY-64);
    indexTir++;
    if (indexTir==36) {
      indexTir=0;
      demandeTir=false;
      lancerTir=false;
    }
  }

  if (millis() - timer >= 100) { // On a suffisament attendu pour un mouvement d'aile pas trop rapide ?
    deltaX=mouseX-posX; // position par rapport à la souris
    deltaY=mouseY-posY;
    int distance=(int) sqrt(sq(deltaX)+sq(deltaY)); // changement type de vol selon la proximité de la souris
    if (cracherFeu&&index%8==6) { // moment de l'animation ou le dragon crache, on tire !
      lancerTir=true;
      tirX=posX;
      tirY=posY;
    }
    if (cracherFeu&&index%8==0) { // fin de l'animation du dragon qui crache
      cracherFeu=false;
      proportionDeplacement=0.1;
    }
    if (attaqueCaudale&&index%8==0) { // fin de l'animation du dragon qui attaque
      attaqueCaudale=false;
      demandeTir=false;
      proportionDeplacement=0.1;
    }
    
    if (distance<150) departAnim=0; 
    else departAnim=8; // 0 pour vol stationnaire, 8 pour vol couché, 24 pour tir
    if (!lancerTir&&((demandeTir&&(index%8==0))||cracherFeu||attaqueCaudale)) { // lancer l'animation du dragon qui crache ou l'attaque cadale si proche
      if (distance<150||attaqueCaudale) {
        departAnim=16; 
        attaqueCaudale=true;
      }
      else {
        departAnim=24;
        cracherFeu=true;
      }
    }

    if (deltaX!=0)
      angle= (degrees(atan2(deltaY, deltaX))+0);
    else angle=0;
    //on cherche le numéro de ligne adéquat selon l'angle entre le dragon et la souris: passage de (-180º,180º) vers (0,7) 
    ligne=(round((angle+180)/360*8))%8;
    posX=posX+round(deltaX*proportionDeplacement); // on s'approche de la souris en douceur
    posY=posY+round(deltaY*proportionDeplacement);
    colonne=index%8; // 8 images par animations
    background(255); // on efface l'écran
    image(sprites[departAnim+colonne][ligne], posX-128, posY-128); // et hop, un dragon
    index++; // image suivante la prochaine fois
    timer = millis(); // on récupére le temps en ms pour rythmer l'animation des ailes
  }
}

